#include <bits/stdc++.h>
#define MAXN 200010
using namespace std;

bool a[MAXN];

int main()
{
    long long n, c, q;
    cin >> n >> c >> q;
    string s;
    cin >> s;
    for(int i = 0; i < n; i++)
    {
        a[i] = s[i] - '0';
    }
    if(n <= 4000 && q <= 4000 && c == n)
    {
        for(int P = 0; P < q; P++)
        {
            int l, r;
            cin >> l >> r;
            l--, r--;
            for(int i = l; i <= r; i++)
            {
                a[i] = !a[i];
            }

            int br = 0;
            for(int i = 0; i < n; i++){
                if(a[i])
                    br++;
            }
            cout << br << endl;
        }
        return 0;
    }


    return 0;
}